import es
import gamethread
import random
import popuplib

####--Dominating Level Control--####
dom_low = 3                         #Domination
dom_med = 6                         #Obliteration
dom_high = 10                       #Totally pwned
dom_veryhigh = 20                   #Not worthy to

####--Dominating Reset Control--####
dom_reset_on_map_change = True      #If true, will reset all dominations on a map change
dom_reset_on_team_change = True     #If true, will reset dominations on a player if they change teams
dom_reset_on_disconnect = True      #If true, will reset dominations on a player if they disconnect

####--Dominating Popup Control--####
dom_popup_frequency = 3             #Set the popups to show up every 'x' rounds
dom_popup_top_value = 5             #Sets the number of entries to show in the best/most dominations popups
dom_popup_show_cmd = "!domshow"     #Sets the say command to set popups to show (per player basis)
dom_popup_hide_cmd = "!domhide"     #Sets the say command to set popups to hide (per player basis)
dom_popup_mydoms_cmd = "!mydom"     #Sets the say command to show personal dominatons popup (per player basis)

####--Dominating Sound Control--####
#dom_sound_enabled = False            #Set if you want sounds to be used or not
#dom_sound_music_volume = 0.9        #Set the volume of the musics (0.0 - 1.0)
#dom_sound_taunt_volume = 1.0        #Set the volume of the taunts (0.0 - 1.0)
#dom_sound_mute_cmd = "!dommute"     #Sets the say command to set sounds to mute (per player basis)
#dom_sound_unmute_cmd = "!domunmute" #Sets the say command to set sounds to unmute (per player basis)

####--DO NOT EDIT ANYTHING BELOW THIS LINE--####

dominations = {}
domination_counts = {}
domination_records = {}
hidden = {}
muted = {}

adverts = {
    1: "#green[DOM]#default Want to see who you are dominating? Or maybe you want to know who your nemesis is? Just type#green " + dom_popup_mydoms_cmd + "#default into the chat window.",
    2: "#green[DOM]#default Want to get rid of these dominating popups? Just type#green " + dom_popup_hide_cmd + "#default into the chat window.",
    3: "#green[DOM]#default Got rid of the dominating popups, and you want to get them back? Just type#green " + dom_popup_show_cmd + "#default into the chat window.",
    4: "#green[DOM]#lightgreen Dominations#default occur when someone kills someone else#green " + str(dom_low) + " times#default before they return a kill.",
    5: "#green[DOM]#lightgreen Obliterations#default occur when someone kills someone else#green " + str(dom_med) + " times#default before they return a kill.",
    6: "#green[DOM]#lightgreen Total Pwnage#default occurs when someone kills someone else#green "+ str(dom_high) + " times#default before they return a kill.",
    7: "#green[DOM]#default If you are#lightgreen Simply not worthy#default to someone, that means they've killed you at least#green " + str(dom_veryhigh) + " times#default without you returning a kill.",
    8: "#green[DOM]#default Want to get rid of these dominating sounds? Just type#green " + dom_sound_mute_cmd + "#default into the chat window.",
    9: "#green[DOM]#default Got rid of the dominating sounds, and you want to get them back? Just type#green " + dom_sound_unmute_cmd + "#default into the chat window."}

round_c = 0

domPopup = None

def load():
    global dom_popup_mydoms_cmd
    global dom_hide_mydoms_cmd
    global dom_sound_mute_cmd
    global dom_sound_unmute_cmd
    if not es.exists('saycommand', dom_popup_mydoms_cmd):
        es.regsaycmd(dom_popup_mydoms_cmd, "dominating/show_your_dominations", 'Shows your dominations')

    if not es.exists('saycommand', dom_popup_hide_cmd):
        es.regsaycmd(dom_popup_hide_cmd, "dominating/hide_popups", 'Hide popups')

    if not es.exists('saycommand', dom_popup_show_cmd):
        es.regsaycmd(dom_popup_show_cmd, "dominating/show_popups", 'Show popups')

    #if not es.exists('saycommand', dom_sound_mute_cmd):
    #    es.regsaycmd(dom_sound_mute_cmd, "dominating/mute_sounds", 'Mute sounds')

    #if not es.exists('saycommand', dom_sound_unmute_cmd):
    #    es.regsaycmd(dom_sound_unmute_cmd, "dominating/unmute_sounds", 'Unmute sounds')

    random.seed()
    #if dom_sound_enabled:
    #    es.stringtable("downloadables", "sound/tf2sounds/tf_nemesis.mp3")
    #    es.stringtable("downloadables", "sound/tf2sounds/tf_revenge.mp3")
    #    for i in range(1, 17):
    #        es.stringtable("downloadables", "sound/tf2sounds/taunts/taunts" + str(i) + ".mp3")
        
def unload():
    global dominations
    global domination_counts
    global domination_records
    dominations.clear()
    domination_counts.clear()
    domination_records.clear()
    es.unregsaycmd(dom_popup_mydoms_cmd)
    es.unregsaycmd(dom_popup_hide_cmd)
    es.unregsaycmd(dom_popup_show_cmd)
    #es.unregsaycmd(dom_sound_mute_cmd)
    #es.unregsaycmd(dom_sound_unmute_cmd)

def es_map_start(event_var):
    global dominations
    global domination_counts
    global domination_records
    if dom_reset_on_map_change:
        dominations.clear()
        domination_counts.clear()
        domination_records.clear()
    #if dom_sound_enabled:
    #    es.stringtable("downloadables", "sound/tf2sounds/tf_nemesis.mp3")
    #    es.stringtable("downloadables", "sound/tf2sounds/tf_revenge.mp3")
    #    for i in range(1, 17):
    #        es.stringtable("downloadables", "sound/tf2sounds/taunts/taunts" + str(i) + ".mp3")
        
def player_team(event_var):
    global dominations
    global dom_reset_on_team_change
    if dom_reset_on_team_change:
        for key in dominations.keys():
            if event_var['userid'] in key.split('<'):
                del dominations[key]

def player_disconnect(event_var):
    global dominations
    global dom_reset_on_disconnect
    global hidden
    global muted
    if event_var['userid'] in hidden.keys():
        del hidden[event_var['userid']]
    if event_var['userid'] in muted.keys():
        del muted[event_var['userid']]
    if dom_reset_on_disconnect:
        for key in dominations.keys():
            if event_var['userid'] in key.split('<'):
                del dominations[key]

def round_start(event_var):
    global round_c
    global dom_popup_frequency
    round_c = (round_c + 1) % (dom_popup_frequency * 3)
    
    if round_c == 0:
        es.doblock("dominating/show_current_dominations")
    
    if round_c == dom_popup_frequency:
        es.doblock("dominating/show_most_dominations")
        
    if round_c == dom_popup_frequency * 2:
        es.doblock("dominating/show_best_dominations")
        
    #if dom_sound_enabled:
    #    es.msg("#multi", adverts[random.randint(1,9)])
    #else:
        es.msg("#multi", adverts[random.randint(1,7)])
            
def player_death(event_var):
    global muted
    global dominations
    global domination_counts
    global domination_records
    global dom_low
    global dom_med
    global dom_high
    global dom_veryhigh
    centermess = ''
    str1 = event_var['userid'] + '<' + event_var['attacker']
    str2 = event_var['attacker'] + '<' + event_var['userid']
    if str1 in dominations.keys():
        dominations[str1] += 1
        if str2 in dominations.keys():
            if dominations[str2] >= dom_low and dominations[str2] < dom_high:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_revenge.mp3', dom_sound_music_volume)
                centermess = es.getplayername(event_var['attacker']) + ' got revenge on ' + es.getplayername(event_var['userid']) + '!'              
            if dominations[str2] >= dom_med:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' finally got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')                
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_revenge.mp3', dom_sound_music_volume)
                centermess = es.getplayername(event_var['attacker']) + ' finally got revenge on ' + es.getplayername(event_var['userid']) + '!'
            del dominations[str2]
        
        if dominations[str1] >= dom_low:
            if str1 in domination_records.keys():
                if dominations[str1] > domination_records[str1]:
                    domination_records[str1] = dominations[str1]
            else:
                domination_records[str1] = dominations[str1]
        
        if dominations[str1] == dom_low:
            if str1 in domination_counts.keys():
                domination_counts[str1] += 1
            else:
                domination_counts[str1] = 1
            if es.getplayerteam(event_var['userid']) == es.getplayerteam(event_var['attacker']):
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is being#lightgreen back-stabbed#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_nemesis.mp3', dom_sound_music_volume)
                centermess = es.getplayername(event_var['userid']) + ' is being back-stabbed by ' + es.getplayername(event_var['attacker']) + '!'              
                es.tell(event_var['userid'], '#multi', '#green[DOM] Your teammate is back-stabbing you!')
                es.tell(event_var['userid'], '#multi', '#green[DOM] They will be punished for their sins!')
                es.tell(event_var['attacker'], '#multi', '#green[DOM] You are back-stabbing!')
                es.tell(event_var['attacker'], '#multi', '#green[DOM] For this you will be punished with death!')
                gamethread.delayed(1.0, es.sexec, (event_var['attacker'], 'kill'))
                del dominations[str1]
            else:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is being#lightgreen dominated#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_nemesis.mp3', dom_sound_music_volume)
                #    gamethread.delayed(1.6, play_taunt, random.randint(1, 16))
                centermess = es.getplayername(event_var['userid']) + ' is being dominated by ' + es.getplayername(event_var['attacker']) + '!'              
                es.tell(event_var['userid'], '#multi', '#green[DOM] You have a#lightgreen new nemesis!')
                es.tell(event_var['userid'], '#multi', '#green[DOM] Get your revenge on#lightgreen ' + es.getplayername(event_var['attacker']) + '#green now!!')
        if dominations[str1] == dom_med:
            es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is now being#lightgreen obliterated#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
            #if dom_sound_enabled:
            #    for ply in es.getUseridList():
            #        if not ply in muted.keys():
            #            es.playsound(ply, 'tf2sounds/tf_nemesis.mp3', dom_sound_music_volume)
            #    gamethread.delayed(1.6, play_taunt, random.randint(1, 16))
            centermess = es.getplayername(event_var['userid']) + ' is now being obliterated by ' + es.getplayername(event_var['attacker']) + '!'              
            es.tell(event_var['userid'], '#multi', '#[DOM] greenYour are being obliterated by your nemesis!')
            es.tell(event_var['userid'], '#multi', '#[DOM] greenGet your revenge on#lightgreen ' + es.getplayername(event_var['attacker']) + '#green now!!')
        if dominations[str1] == dom_high:
            es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is now being#lightgreen totally pwned#default by#green ' + es.getplayername(event_var['attacker']) + '#default!')
            #if dom_sound_enabled:
            #    for ply in es.getUseridList():
            #        if not ply in muted.keys():
            #            es.playsound(ply, 'tf2sounds/tf_nemesis.mp3', dom_sound_music_volume)
            #    gamethread.delayed(1.6, play_taunt, random.randint(1, 16))
            centermess = es.getplayername(event_var['userid']) + ' is now being totally pwned by ' + es.getplayername(event_var['attacker']) + '!'              
            es.tell(event_var['userid'], '#multi', '#[DOM] greenYou are being totally pwned by your nemesis!')
            es.tell(event_var['userid'], '#multi', '#[DOM] greenGet your revenge on#lightgreen ' + es.getplayername(event_var['attacker']) + '#green now!!')
        if dominations[str1] == dom_veryhigh:
            es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['userid']) + ' is now #lightgreen simply not worthy#default compared to#green ' + es.getplayername(event_var['attacker']) + '#default!')
            #if dom_sound_enabled:
            #    for ply in es.getUseridList():
            #        if not ply in muted.keys():
            #            es.playsound(ply, 'tf2sounds/tf_nemesis.mp3', dom_sound_music_volume)
            #    gamethread.delayed(1.6, play_taunt, random.randint(1, 16))
            centermess = es.getplayername(event_var['userid']) + ' is now simply not worthy compared to ' + es.getplayername(event_var['attacker']) + '!'              
            es.tell(event_var['userid'], '#multi', '#green[DOM] You are simply not worthy compared your nemesis!')
            es.tell(event_var['userid'], '#multi', '#green[DOM] Get your revenge on#lightgreen ' + es.getplayername(event_var['attacker']) + '#green now!!')
    else:
        dominations[str1] = 1
        if str2 in dominations.keys():
            if dominations[str2] >= dom_low and dominations[str2] < dom_high:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_revenge.mp3', dom_sound_music_volume)
                centermess = es.getplayername(event_var['attacker']) + ' got revenge on ' + es.getplayername(event_var['userid']) + '!'              
            if dominations[str2] >= dom_high:
                es.msg('#multi', '#green[DOM]#default ' + es.getplayername(event_var['attacker']) + ' finally got revenge on#green ' + es.getplayername(event_var['userid']) + '#default!')                
                #if dom_sound_enabled:
                #    for ply in es.getUseridList():
                #        if not ply in muted.keys():
                #            es.playsound(ply, 'tf2sounds/tf_revenge.mp3', dom_sound_music_volume)
                centermess = es.getplayername(event_var['attacker']) + ' finally got revenge on ' + es.getplayername(event_var['userid']) + '!'              
            del dominations[str2]
    
    if centermess != '':
        gamethread.delayed(0.1, es.centermsg, centermess)
        gamethread.delayed(1.1, es.centermsg, centermess)
        gamethread.delayed(2.1, es.centermsg, centermess)
        gamethread.delayed(3.1, es.centermsg, centermess)
        gamethread.delayed(4.1, es.centermsg, centermess)

#def play_taunt(number):
#    global muted
#    for ply in es.getUseridList():
#        if not ply in muted.keys():
#            es.playsound(ply, 'tf2sounds/taunts/taunts' + str(number) + '.mp3', dom_sound_taunt_volume)

def show_current_dominations():
    global hidden
    global domPopup
    global dominations
    global dom_low
    
    if popuplib.exists('domPopup'):
        popuplib.delete('domPopup')

    domPopup = popuplib.create('domPopup')
    domPopup.addline("Current Dominations")
    domPopup.addline(" ")
    
    key_list = getsortkey(dominations)
    
    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= dom_low:
            count += 1
            domPopup.addline(es.getplayername(split_key[1]) + " is dominating " + es.getplayername(split_key[0]) + " (" + str(dominations[key]) + ")")    
    if count == 0:
        domPopup.addline("No dominations")
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            domPopup.send(ply)
            gamethread.delayed(5.0, domPopup.unsend, ply)
    
def show_your_dominations():
    global domPopup
    global dominations
    global dom_low
    
    user = es.getcmduserid()
    
    if popuplib.exists('domPopup'):
        popuplib.delete('domPopup')
    
    domPopup = popuplib.create('domPopup')
    domPopup.addline("Your Dominations")

    key_list = getsortkey(dominations)
    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= dom_low and str(user) == split_key[1]:
            count += 1
            domPopup.addline(es.getplayername(split_key[0]) + " (" + str(dominations[key]) + ")")
                
    if count == 0:
        domPopup.addline("No dominations")
        
    domPopup.addline(" ")
    domPopup.addline("Your Nemesis'")

    count = 0 
    for key in key_list:
        split_key = key.split('<')
        if dominations[key] >= dom_low and str(user) == split_key[0]:
            count += 1
            domPopup.addline(es.getplayername(split_key[1]) + " (" + str(dominations[key]) + ")")
                
    if count == 0:
        domPopup.addline("No nemesis'")
    
    domPopup.send(user)
    gamethread.delayed(5.0, domPopup.unsend, user)
    
def show_most_dominations():
    global hidden
    global domPopup
    global domination_counts
    global dom_low
    
    if popuplib.exists('domPopup'):
        popuplib.delete('domPopup')
    
    domPopup = popuplib.create('domPopup')
    domPopup.addline("Most Dominations")
    domPopup.addline(" ")
    
    key_list = getsortkey(domination_counts)
    count = 0
    for key in key_list:
        split_key = key.split('<')
        count += 1
        domPopup.addline('->' + str(count) + '. ' + es.getplayername(split_key[1]) + ' dominating ' + es.getplayername(split_key[0]) + ' ' + str(domination_counts[key]) + ' times')
        if count == dom_popup_top_value:
            break
    
    if count == 0:
        domPopup.addline('No dominations')
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            domPopup.send(ply)
            gamethread.delayed(5.0, domPopup.unsend, ply)

def show_best_dominations():
    global hidden
    global domPopup
    global domination_records
    global dom_low
    
    if popuplib.exists('domPopup'):
        popuplib.delete('domPopup')
    
    domPopup = popuplib.create('domPopup')
    domPopup.addline("Best Dominations")
    domPopup.addline(" ")
    
    key_list = getsortkey(domination_records)
    count = 0
    for key in key_list:
        split_key = key.split('<')
        if domination_records[key] >= dom_low:
            count += 1
            domPopup.addline('->' + str(count) + '. ' + str(domination_records[key]) + ' (' + es.getplayername(split_key[1]) + ' dominating ' + es.getplayername(split_key[0]) + ')')
        if count == dom_popup_top_value:
            break

    if count == 0:
        domPopup.addline('No dominations')
    
    for ply in es.getUseridList():
        if not ply in hidden.keys():
            domPopup.send(ply)
            gamethread.delayed(5.0, domPopup.unsend, ply)

def getsortkey(d):
    rev_items = [(v,k) for k, v in d.items()]
    rev_items.sort(reverse=True)
    return [k for (v,k) in rev_items]    

def hide_popups():
    global hidden
    global dom_popup_show_cmd
    user = es.getcmduserid()
    es.tell(user, "#multi", "#green[DOM]#default You are now hiding dominating popups.")
    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_popup_show_cmd + " to unhide the dominating popups.")
    hidden[user] = 1

def show_popups():
    global hidden
    global dom_popup_hide_cmd
    user = es.getcmduserid()
    es.tell(user, "#multi", "#green[DOM]#default You are now unhiding dominating popups.")
    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_popup_hide_cmd + " to hide the dominating popups.")
    if user in hidden.keys():
        del hidden[user]

#def mute_sounds():
#    global muted
#    global dom_sounds_unmute_cmd
#    user = es.getcmduserid()
#    es.tell(user, "#multi", "#green[DOM]#default You are now muting dominating sounds.")
#    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_sound_unmute_cmd + " to unmute to dominating sounds.")
#    muted[user] = 1

#def unmute_sounds():
#    global muted
#    global dom_sound_mute_cmd
#    user = es.getcmduserid()
#    es.tell(user, "#multi", "#green[DOM]#default You are now unmuting dominating sounds.")
#    es.tell(user, "#multi", "#green[DOM]#default If you change your mind, you can say " + dom_sound_mute_cmd + " to mute to dominating sounds.")
#    if user in muted.keys():
#        del muted[user]    
